<template>
    <div class="">
            <b-modal :lazy="true" :static="true" v-show="true" @hidden="reset"  size="xl" ref="chgdImageModal" id="modal-gallery" :title="ModalTitle"  :hide-footer="false">
                <div class="" method="POST"  @submit.prevent="update()" @reset.prevent="reset()" @keydown="form.errors.clear($event.target.name)"
                      @change="form.errors.clear($event.target.name)">
                        <div class="d-flex justify-content-between">
                                <div class="w-100">
                                    <div class="image-gallery-content d-flex align-content-between flex-wrap">
                                            <vue-dropzone 
                                                ref="dropzone"
                                                @vdropzone-max-files-reached="maxFilesReached"
                                                @vdropzone-removed-file="removedfileFromDropzone"
                                                @vdropzone-file-added="fileAdded" 
                                                @vdropzone-success="registerFile"
                                                :duplicate-check="true"
                                                @vdropzone-mounted="dropzoneReady"
                                                id="dropzone2" 
                                                :options="dropzoneOptions">
                                            </vue-dropzone>
                                    </div>
                                </div>
                        </div>
             

                </div>
                      <template v-slot:modal-footer>
        <div class="w-100">
                    <div class="m-form__actions m-form__actions--solid mt-0" style="    display: flex;align-items: center;justify-content: flex-end;">
                        <button type="button" @click="update" :class="['btn btn-success btn-small ',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
                    </div>
        </div>
      </template>
            </b-modal>
            <!-- Modal fin -->
        </div>
</template>

<script>

import Form from "./../../classes/Form"
import vue2Dropzone from 'vue2-dropzone'


    export default {
        props:['vehicule'],
        data(){
            return{
                //VC-calendar
                FileIsLoading:false,
                FileLimit:6,
                fileToPreload:0,
                init : false,

                defaultImage:null,
                opt:{
                    marques:[],
                    motorisations:[],
                    tvehicules:[],
                    optConfort:[],
                    optPlaisir:[],
                    optSecurite:[],
                    tpermis:[],
                },
                entity:
                {
                    id:"",
                    image_mise_en_avant:null
                },
                
                dropzoneOptions: 
                {
                 url:"/api/vehicules/"+this.vehicule.id+"/updateImages",
                 method:'patch',
                 autoQueue:false,
                 thumbnailWidth: 150,
                 maxFilesize: 1.5,
                 acceptedFiles:'image/jpeg,image/jpg,image/png',
                 maxFiles:this.FileLimit,
                 dictCancelUpload:" Annuler ",
                 dictFileTooBig:"La taille de cette photo dépasse la limite de {{maxFilesize}} Mo",
                 dictCancelUploadConfirmation:"Supprimer",
                 dictRemoveFile:" Supprimer ",
                 dictDefaultMessage: "<i class='fas fa-cloud-upload-alt mr-2 fa-2x'></i> Glisser ou charger des images  ici pour la galerie de la voiture </br>(4 images maximum)",
                 addRemoveLinks: true,
                 headers: {
          	   	 Authorization: `Bearer ${window.App.api_token}`
        	      },
                },
                form : new Form(
                    {
                        image_mise_en_avant:"",
                        images:[],
                        vehicule_id:"",
                  }),
                isLoading:false,
            }
        },
        created()
        {
               this.modeEdit = false         
        },
        mounted() {

            this.entity = this.vehicule
            this.form.vehicule_id = this.vehicule.id
            this.form.image_mise_en_avant = ""
            this.form.images =this.getImages
            this.FileLimit = 4

            this.defaultImage =this.vehicule.image_mise_en_avant
            this.dropzoneOptions.url = "/api/vehicules/"+this.vehicule.id+"/updateImages"
            //

              window.event.$on('change-images-event',(vehicule) =>
             {
                this.form.vehicule_id = this.vehicule.id
                this.form.image_mise_en_avant = ""
                this.form.images =this.getImages
                this.FileLimit = 4

            this.defaultImage =this.vehicule.image_mise_en_avant
            this.dropzoneOptions.url = "/api/vehicules/"+this.vehicule.id+"/updateImages"
                 
                 this.showModal()
                
             })


 
        },
        computed:
            {
                ModalTitle ()
                {
                    return "Galerie"
                },
                ModalAction ()
                {
                    return  " Valider"
                },

                canAddFile()
                {
                    return 0
                },
                getImages()
                {
                return this.vehicule.images.map((item) => {
                      return   item.chemin

                })
                },
            },
        methods:
            {
                 
                 dropzoneReady()
                 {
                     this.initDropzone()
                 },
                 initDropzone()
                 {
                     console.log(this.entity.images);
                  this.fileToPreload = this.entity.images.length
                 for (var i = 0; i < this.entity.images.length; i++) {

                    var file = { size: 123, name: this.entity.images[i], type: "image/png",addedManually:true };
                    var url = '/storage/images/'+this.entity.images[i].chemin;
                    console.log(url);
                    this.$refs.dropzone.manuallyAddFile(file,url);
                    }
                 },
                //Actualise les données générales
                update()
                {
                    this.isLoading = true ;
                    //Requête ajax
                    this.form.patch("/api/vehicules/"+this.entity.id+"/updateImages").then((response) =>
                        {
                            if(response.success)
                            {
  
                              if(response.profileWasUpdated && response.galleryWasUpdated )
                              
                              {
                                  window.event.$emit('profile-updated-event',{profile:response.profile,images:response.images})
                                  window.event.$emit('gallery-updated-event',{profile:response.profile,images:response.images})
                              }
                              else if(!response.profileWasUpdated && response.galleryWasUpdated)
                              {
                                  window.event.$emit('gallery-updated-event',{profile:response.profile,images:response.images})
                              }
                            else if(response.profileWasUpdated && !response.galleryWasUpdated)
                              {
                                  window.event.$emit('profile-updated-event',{profile:response.profile,images:response.images})
                              }

                                  flash(response.message) 
                            
                               

                            }
                            else
                            {
                             flash("<span>Ajout<strong> impossible</strong></span>","error")
                            }
                           this.reset()
                           this.isLoading = false ;

                        },
                        (error) =>
                        {
                            this.isLoading = false
                        });
                },
                //On affiche le modal 
                showModal()
                {

                    this.modeEdit = false
                    this.$refs['chgdImageModal'].show()


                },

                //Initialisation du formulaire
                reset()
                {
                    this.form.image_mise_en_avant = ""
                    this.form.images=[],
                    this.form.vehicule_id=this.vehicule.id,
                    this.$refs['chgdImageModal'].hide()
                    this.modeEdit = false
                    this.isLoading = false
                },
             // Events
            //Charge l'image
            readURL(event)
            {
               // this.imageProfileIsLoading = true
                  var input = event.srcElement;
                  if (input.files && input.files[0]) {
                var reader = new FileReader();
                  var vm = this
                reader.onload = function (e)
                {
                    $('.image-uploader-content img').attr('src', e.target.result);
                    vm.form.image_mise_en_avant = e.target.result;
                   // vm.imageProfileIsLoading = false
                };
                reader.readAsDataURL(input.files[0]);
            }},
             //Retire l'image des
            removeImage(index)
            {
               this.form.images.splice(index,1)

            },
            //Charge les images de la galerie
            readURLGalerie(event)
            {
                  var input = event.srcElement;
                  this.imageGalleryIsLoading = true
                  if (input.files && input.files[0])
                  {

                      var index = 0
                      var vm = this
                      //this.fileCounter = input.files.length
                     // this.imageGalleryIsLoading = true
                      for(index;index<input.files.length;index++)
                      {
                        var reader = new FileReader();
                        reader.onload = function (e)
                        {
                            //$('.image-uploader-content img').attr('src', e.target.result);
                            //vm.form.image_mise_en_avant = e.target.result;
                            vm.form.images.push(e.target.result)
                           // vm.fileCounter--

                        };
                        reader.readAsDataURL(input.files[index]);
                      }
                   }
            }
             ,registerFile(event)
            {
              this.form.images.push(event.dataURL)
              this.FileIsLoading = false
            },
            removedfileFromDropzone(file, error, xhr)
            {
                console.log(file)
               var file = file.hasOwnProperty('dataURL') ? file.dataURL : file.name.chemin
                var oldSize = this.form.images.length
                this.form.images= this.form.images.filter(e => { return e !==file })
 
                if(this.form.images.length != oldSize)
                {
                    this.FileLimit++
                }

            },
            fileAdded(event)
            {
              if(event.hasOwnProperty("addedManually"))
              {
                   this.FileLimit--
                   return 
              }
              var reader = new FileReader();
              var vm = this
              reader.onload = function (e)
              {
                    if(vm.FileLimit > 0)
                    {
                        vm.form.images.push(e.target.result)
                        vm.FileLimit--;
                    }
                    else
                    {
                        vm.$refs.dropzone.removeFile(event)
                    }
                   
            
              };
            
             reader.readAsDataURL(event);
             
       
              
            },
            maxFilesReached(file)
            {
              //console.log(file)
              //this.$refs.dropzone.removeFile(file)
            },


        },
        components:
         {
          vueDropzone: vue2Dropzone
         },
    }
</script>
<style lang="css">
#dropzone2 .dz-preview .dz-image img {
    display: block;
    object-fit: cover !important;
}
#dropzone2 
{
    padding:0px;
}
.image-gallery-content .vue-dropzone
{
  margin-top: 0px;

}
#modal-gallery .modal-body {

    padding: 0;
}
</style>